theory Bla
imports Main
begin

locale P =
  fixes P
  assumes P: "P"
begin

definition "p = (if P then Suc else undefined)"

lemma foo: "p = Suc"
using P unfolding p_def by auto

end

definition "f = P.p True"

interpretation P True
rewrites
  "P.p True = f"
apply (unfold_locales) apply (auto simp: f_def)
done

lemmas foo [code]


declare [[show_abbrevs=false]]
term (noabbrevs) p

term p

thm P.p_def

export_code p in Haskell

end